<!DOCTYPE html>
<html>

<head>

  <script>
    const HOST_BASE = "<%= process.env.HOST_BASE %>"
  </script>
  <base href="<%= process.env.HOST_BASE ? `/${process.env.HOST_BASE}/` : '/' %>" />
  <title><%= title %></title>
  <link rel='stylesheet' href='stylesheets/style.css' />
  
  <!-- bootstrap -->
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css">
  <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"></script>

  <!-- Datable -->
  <!-- <link rel="stylesheet" href="https://cdn.datatables.net/1.10.21/css/jquery.dataTables.min.css"> -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.21/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.21/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.21/js/dataTables.bootstrap4.min.js"></script>

  <script src="https://ajax.googleapis.com/ajax/libs/angularjs/1.7.9/angular.min.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/lodash@4.17.15/lodash.min.js"></script>

  <!-- ui-bootstrap -->
  <script src="js/ui-bootstrap-tpls-3.0.6.js"></script>

  <!-- Multiple Select -->
  <!-- <link rel="stylesheet" href="https://rawgit.com/tamtakoe/oi.select/master/dist/select.css" /> -->
  <!-- <script src="https://rawgit.com/tamtakoe/oi.select/master/dist/select.js"></script> -->
  <!-- <script src="https://rawgit.com/tamtakoe/oi.select/master/dist/select-tpls.js"></script> -->

  <!-- Fontawesome -->
  <link rel="stylesheet" href="stylesheets/fontawesome-all.css">
  <script src="js/fontawsome-all.js"></script>

  <!-- ui-notification -->
  <link rel="stylesheet" href="https://rawgit.com/alexcrack/angular-ui-notification/master/dist/angular-ui-notification.css" />
  <script src="https://rawgit.com/alexcrack/angular-ui-notification/master/dist/angular-ui-notification.js"></script>

  <script src="js/app.js"></script>
</head>

<body ng-app="app">

  <nav class="navbar navbar-expand-lg navbar-dark bg-dark fixed-top mb-3 sticky-top" ng-controller="navBarController">
    <a class="navbar-brand" href="#"><%= title %></a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent"
      aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav ml-auto nav-flex-icons">
        <li class="nav-item dropdown">
          <a class="nav-link dropdown-toggle" id="navbarDropdownMenuLink" data-toggle="dropdown"
            aria-haspopup="true" aria-expanded="false" href="#">
            <i class="fas fa-user-alt"></i> 
            {{userInfo.preferred_username}}
          </a>
          <div class="dropdown-menu dropdown-menu-right dropdown-default"
            aria-labelledby="navbarDropdownMenuLink">
            <a class="dropdown-item" href="logout"><i class="fas fa-sign-out-alt"></i> Logout</a>
          </div>
        </li>
      </ul>
    </div>
  </nav>

  <div ng-controller="testController">

    <div class="container-fluid">
      <div class="row">
        <div class="col">

          <div class="card">
            <div class="card-header">
              <div class="d-flex align-items-center">
                <div class="mr-auto">
                  <h5>Requested Trains</h5>
                </div>
                <div class="ml-auto">
                  <a href="" class="btn btn-secondary ml-auto" ng-click="refreshJobTable()"><i class="fas fa-sync"></i> Refresh</a>
                  <a href="" class="btn btn-primary ml-auto" ng-click="openTrainRequestModal()"><i class="fas fa-plus-circle"></i> New Train Request</a>
                </div>
              </div>
            </div>
            <div class="card-body">

              <div class="table-responsive">
                <table id="jobTable" class="table table-sm table-bordered table-striped table-hover compact">
                  <thead class="thead-dark">
                    <tr>
                      <th>No.</th>
                      <th>JOB ID</th>
                      <th>Train Class</th>
                      <th>Curr. Station</th>
                      <th>Next Station</th>
                      <th>Curr. Status</th>
                      <th>Route</th>
                      <th>Last Update</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr ng-repeat="job in jobList">
                      <td>{{$index}}</td>
                      <td>{{job.jobid}}</td>
                      <td>{{job.trainclassid}}</td>
                      <td>{{job.currentstation}}</td>
                      <td>{{job.nextstation != '-1' ? job.nextstation : '-' }}</td>
                      <td class="text-white" ng-class="{'bg-secondary': job.currentstate == 'wait_for_pull' , 'bg-primary': job.currentstate == 'pulled',
                      'bg-success': job.currentstate == 'finished', 'bg-warning': job.currentstate == 'reject' }">
                        <span ng-if="job.currentstate == 'reject'">
                          <a href="" class="card-link" ng-click="openTrainRejectHandlerModal(job)">
                            <i class="fas fa-hand-pointer"></i> {{job.currentstate}}
                          </a>
                        </span>
                        <span ng-if="job.currentstate != 'reject'">{{job.currentstate}}</span>
                      </td>
                      <td class="route">
                        <span ng-repeat="station in job.route track by $index" uib-tooltip="{{job.stationmessages[$index]}}">
                          {{station}} : {{job.visited[$index] == -2 ? '&#128683;' : job.visited[$index] == -1 ? '&#9989;' : '&#8987;' }}
                          (<span>{{job.stationmessages[$index]}}</span>)
                          <hr class="m-1" ng-if="$index + 1 < job.route.length">
                        </span>
                      </td>
                      <td data-order="{{job.updatedAt}}">{{job.updatedAtReadable}}</td>
                    </tr>
                  </tbody>
                </table>
              </div>

            </div>
          </div>

        </div>
      </div>
    </div>
  </div>
</body>

<script type="text/ng-template" id="trainRequestModal.html">


  <div class="modal-header">
    <h3 class="modal-title">Make a Train Request</h3>
  </div>

  <form name="makeTrainRequestForm" ng-submit="makeTrainRequest()">
    <div class="modal-body">
      <div class="row">
        <div class="col">
  
          <div class="form-row">
  
            <div class="col form-group">
              <label for="selectTrain">Select Train:</label>
              <select id="selectTrain" class="form-control"
                ng-options="job as job.tag_name group by job.name for job in trainClassListFlattened"
                ng-model="trainRequestData.trainclass"
                ng-required="true">
                <option disabled></option>
              </select>
  
            </div>
          </div>
          <div class="form-row">  
            <div class="col form-group">
              <label for="selectRoute">Select Route:</label>
              <div class="form-row" id="selectRoute">
                <div class="col-auto my-1" ng-repeat="row in trainRequestData.route track by $index">
                  <div class="input-group input-group-sm">
                    <div class="input-group-prepend">
                      <span class="input-group-text">{{$index + 1}}</span>
                    </div>
                    <!-- use this for filtering -->
                    <!-- | filterPrevSelectedStation:$index:trainRequestData.route -->
                    <select class="form-control form-control-sm font-weight-bolder"
                      ng-options="station.name as station.name for station in stationList" 
                      ng-model="trainRequestData.route[$index]"
                      ng-required="true">
                      <option disabled></option>
                    </select>
                    <div class="input-group-append">
                      <button type="button" class="btn btn-secondary" ng-click="removeStation($index)"><i class="fas fa-minus"></i></button>
                      <button type="button" class="btn btn-primary" ng-if="$index == trainRequestData.route.length -1" ng-click="addStation($index)"><i class="fas fa-plus"></i></button>
                      <span class="input-group-text" ng-if="$index < trainRequestData.route.length -1"><i class="fas fa-angle-double-right"></i></span>
                    </div>
                  </div>
                </div>
              </div>
            </div>  
  
          </div>

        </div>
      </div>

      <div class="row">

        <div class="col-12">
          <div class="card">
            <div class="card-body">
              <div class="card-text">
                <strong>Description: </strong>{{trainRequestData.trainclass.description || 'None'}}
              </div>
              <div class="card-text">
                <strong>Train: </strong>{{ trainRequestData.trainclass ? trainRequestData.trainclass.name + ':' + trainRequestData.trainclass.tag_name : 'Not Selected'}}
              </div>
              <div class="card-text">
                <strong>Route: </strong> {{trainRequestData.route.join(' &rArr; ') || 'Not Selected'}}
              </div>
  
            </div>
          </div>
        </div>
        
      </div>
  
    </div>
  
    <div class="modal-footer">
      <button type="button" class="btn btn-warning" ng-click="cancel()">Cancel</button>
      <button type="submit" class="btn btn-primary">Submit</button>
    </div>
  </form>

</script>

<script type="text/ng-template" id="trainRejectHandlerModal.html">


  <div class="modal-header">
    <h3 class="modal-title">Train Reject</h3>
  </div>

  <div class="modal-body">
    <div class="row">
      <div class="col">

        <div class="card">
          <div class="card-body">
            <p>Station [{{job.currentstation}}] has rejected your train.</p>
            <p>Message: {{stationMessage}}</p>
          </div>
        </div>

      </div>
    </div>
  </div>

  <div class="modal-footer">
    <button type="button" class="btn btn-warning" ng-click="cancel()">Cancel</button>
    <button type="button" class="btn btn-primary" ng-click="skipCurrentStation()" uib-tooltip="{{getTooltipText(false)}}">Skip Once</button>
    <button type="button" class="btn btn-secondary" ng-click="skipCurrentStation(true)" uib-tooltip="{{getTooltipText(true)}}">Skip All</button>
  </div>

</script>


</html>